// Task 1 - Draw random colored ellipses across the screen with for loops
function setup() {
    createCanvas(500, 500);
    background(0); // Set background color to black
    noStroke();
  }
  
  function draw() {
    // Task 1: Create ellipses across the canvas with random colors
    for (let x = 25; x < width; x += 50) {
      for (let y = 25; y < height; y += 50) {
        fill(random(255), random(255), random(255)); // Random fill color
        ellipse(x, y, 50, 50); // Draw ellipse
      }
    }
    
    // Task 2: Interactive circle that follows the mouse with easing
    let easing = 0.05;
    let targetX = mouseX;
    let targetY = mouseY;
    let x = targetX - (targetX - pmouseX) * easing;
    let y = targetY - (targetY - pmouseY) * easing;
    
    fill(255, 0, 0); // Red color
    ellipse(x, y, 50, 50); // Draw circle following mouse
    
    // Task 3: Create random lines when the mouse is pressed
    if (mouseIsPressed) {
      stroke(random(255), random(255), random(255)); // Random color
      strokeWeight(4);
      line(mouseX, mouseY, pmouseX, pmouseY); // Draw line from last mouse position
    }
    
    // Task 4: Interactive patterns when a key is pressed
    if (keyIsPressed) {
      switch (key) {
        case "1":
          drawStar(100, 100, 20, 40, 5); // Draw star pattern
          break;
        case "2":
          drawSpiral(300, 300, 10, 5); // Draw spiral pattern
          break;
        case "3":
          drawHexagon(400, 400, 30); // Draw hexagon pattern
          break;
      }
    }
  }
  
  // Task 4: Function to draw a star pattern
  function drawStar(x, y, radius1, radius2, npoints) {
    let angle = TWO_PI / npoints;
    let halfAngle = angle / 2.0;
    beginShape();
    for (let a = -PI/4; a < TWO_PI; a += angle) {
      let sx = x + cos(a) * radius2;
      let sy = y + sin(a) * radius2;
      vertex(sx, sy);
      sx = x + cos(a + halfAngle) * radius1;
      sy = y + sin(a + halfAngle) * radius1;
      vertex(sx, sy);
    }
    endShape(CLOSE);
  }
  
  // Task 4: Function to draw a spiral pattern
  function drawSpiral(x, y, initialRadius, growth) {
    noFill();
    stroke(255, 255, 0); // Yellow color for spiral
    strokeWeight(2);
    beginShape();
    for (let i = 0; i < 200; i++) {
      let radius = initialRadius + i * growth;
      let angle = i * 0.1;
      let xPos = x + radius * cos(angle);
      let yPos = y + radius * sin(angle);
      vertex(xPos, yPos);
    }
    endShape();
  }
  
  // Task 4: Function to draw a hexagon pattern
  function drawHexagon(x, y, radius) {
    fill(random(255), random(255), random(255)); // Random color
    stroke(0);
    strokeWeight(1);
    beginShape();
    for (let i = 0; i < 6; i++) {
      let angle = TWO_PI / 6 * i;
      let xPos = x + cos(angle) * radius;
      let yPos = y + sin(angle) * radius;
      vertex(xPos, yPos);
    }
    endShape(CLOSE);
  }
  